Subject: bug#77063: 29.1; ido-read-buffer

From: Keith David Bershatsky <[email-masked]>
Date: Mon, 17 Mar 2025 10:15:20 -0700

I sent out the last email of 09:50:37 without the benefit of reading your email of 09:44:26.  My email of 09:50:37 perhaps addresses what you were seeking in terms of a better recipe.  Yes, there are two (2) distinct problems:

# 1:  The first problem is that no buffer choices are displayed in the minibuffer because there needs to be a call to ido-common-initialization _before_ calling ido-read-internal.  In at least one other section of the ido library, we can observe a call to ido-common-initialization before calling ido-read-internal.  I do not know why we don't just call ido-common-initialization at the bottom of the ido library and remove all other calls from inside functions ... maybe that function is supposed to do something special each time before calling ido-read-internal.

# 2:  The second problem relates to ido-read-buffer throwing the wrong buffer as a result when we use the separate ido completions buffer to choose a buffer instead of using the rotating choices inside the minibuffer.  The correct choice is inserted into the minibuffer, but when pressing RET and exiting ido-read-buffer, the wrong buffer is thrown as a result.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

> Date: [03-17-2025 09:44:26] <17 Mar 2025 18:44:26 +0200>
> From: Eli Zaretskii <[email-masked]>
> To: Keith David Bershatsky <[email-masked]>
> Cc: [email-masked]
> Subject: Re: bug#77063: 29.1; ido-read-buffer
> 
> > Date:  Mon, 17 Mar 2025 08:16:31 -0700
> > From:  Keith David Bershatsky <[email-masked]>
> > Cc:  [email-masked]
> >
> > I do not have a solution for the second problem described in part 2 of 2.
> 
> Oh, so there are two problems in this report?  I thought only the
> second part was the bug, and it's that part which I cannot reproduce
> in Emacs 30.
> 
> Regarding the first part: why it is considered a problem?  Your recipe
> shows some effects of some actions, but please explain what is it you
> consider to be a problematic behavior so it is clear even to those who
> don't use Ido.